<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentDataMin ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPaymentDataMin
 * @subpackage Arrays
 */
class ArrayOfPaymentDataMin extends AbstractStructArrayBase
{
    /**
     * The PaymentDataMin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\PaymentDataMin[]
     */
    public $PaymentDataMin;
    /**
     * Constructor method for ArrayOfPaymentDataMin
     * @uses ArrayOfPaymentDataMin::setPaymentDataMin()
     * @param \patest\StructType\PaymentDataMin[] $paymentDataMin
     */
    public function __construct(array $paymentDataMin = array())
    {
        $this
            ->setPaymentDataMin($paymentDataMin);
    }
    /**
     * Get PaymentDataMin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\PaymentDataMin[]|null
     */
    public function getPaymentDataMin()
    {
        return isset($this->PaymentDataMin) ? $this->PaymentDataMin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentDataMin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentDataMin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentDataMinForArrayConstraintsFromSetPaymentDataMin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentDataMinPaymentDataMinItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentDataMinPaymentDataMinItem instanceof \patest\StructType\PaymentDataMin) {
                $invalidValues[] = is_object($arrayOfPaymentDataMinPaymentDataMinItem) ? get_class($arrayOfPaymentDataMinPaymentDataMinItem) : sprintf('%s(%s)', gettype($arrayOfPaymentDataMinPaymentDataMinItem), var_export($arrayOfPaymentDataMinPaymentDataMinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentDataMin property can only contain items of type \patest\StructType\PaymentDataMin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentDataMin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PaymentDataMin[] $paymentDataMin
     * @return \patest\ArrayType\ArrayOfPaymentDataMin
     */
    public function setPaymentDataMin(array $paymentDataMin = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentDataMinArrayErrorMessage = self::validatePaymentDataMinForArrayConstraintsFromSetPaymentDataMin($paymentDataMin))) {
            throw new \InvalidArgumentException($paymentDataMinArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentDataMin) || (is_array($paymentDataMin) && empty($paymentDataMin))) {
            unset($this->PaymentDataMin);
        } else {
            $this->PaymentDataMin = $paymentDataMin;
        }
        return $this;
    }
    /**
     * Add item to PaymentDataMin value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PaymentDataMin $item
     * @return \patest\ArrayType\ArrayOfPaymentDataMin
     */
    public function addToPaymentDataMin(\patest\StructType\PaymentDataMin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\PaymentDataMin) {
            throw new \InvalidArgumentException(sprintf('The PaymentDataMin property can only contain items of type \patest\StructType\PaymentDataMin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentDataMin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\PaymentDataMin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\PaymentDataMin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\PaymentDataMin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\PaymentDataMin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\PaymentDataMin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentDataMin
     */
    public function getAttributeName()
    {
        return 'PaymentDataMin';
    }
}
